/********************************************************************
  readdlib.c
  VIOS$BMQ(B Read $B=hM}4XO"4X?t(B
*********************************************************************/
#include "vios_lib.h"

int* iRead(char* path, int size, int* data){
  int a,b,i,n,count;
  char buf[256];
  FILE *file;
  if((file = fopen(path,"r")) == NULL){
    puts("File open error");
    exit(0);
  }
  if((data = (int *)malloc(sizeof(int) * size)) == NULL){
    puts("error");
    exit(0);
  }
  n = 0;
  for(i=0;i<size;i++){
    count = 0;
    while( ((a = fgetc(file)) != ' ') && (a != EOF) && (a != '\n')){
      buf[count++] = a;
    }
    buf[count] = '\0';
    data[n++] = atoi(buf);
  }
  fclose(file);
  return(data);
}

FLOAT* fRead(char* path, int size, FLOAT* data){
  int a,b,i,n,count;
  char buf[256];
  FILE *file;
  if((file = fopen(path,"r")) == NULL){
    puts("File open error");
    exit(0);
  }
  if((data = (FLOAT *)malloc(sizeof(FLOAT) * size)) == NULL){
    puts("error");
    exit(0);
  }
  n = 0;
  for(i=0;i<size;i++){
    count = 0;
    while( ((a = fgetc(file)) != ' ') && (a != EOF) && (a != '\n')){
      buf[count++] = a;
    }
    buf[count] = '\0';
    data[n++] = atof(buf);
  }
  fclose(file);
  return(data);
}

int* iReadBin(char* path, int size, int* data){
  int count;
  FILE *file;
  if((file = fopen(path,"r")) == NULL){
    puts("File open error");
    exit(0);
  }
  if((data = (int *)malloc(sizeof(int) * size)) == NULL){
    puts("error");
    exit(0);
  }
  count = fread(data, sizeof(int), size, file);
  fclose(file);
  return(data);
}

FLOAT* fReadBin(char* path, int size, FLOAT* data){
  int count;
  FILE *file;
  if((file = fopen(path,"r")) == NULL){
    puts("File open error");
    exit(0);
  }
  if((data = (FLOAT *)malloc(sizeof(FLOAT) * size)) == NULL){
    puts("error");
    exit(0);
  }
  count = fread(data, sizeof(int), size, file);
  fclose(file);
  return(data);
}
