/**********************************************************
  vsImage.h
  VIOS 2󥯥饹( 2ʬ )
***********************************************************/
#include "module.h"
#include "ip.h"

#ifndef __VS_IMAGE_H
#define __VS_IMAGE_H

template <class T>
class vsImage
{
  protected:
    int		lx;
    int		ly;

    int		w_chk;

    // ۵ѡ̾parallelʸǤ㳰
    vs_request	req;

    T		GetNow(int x, int y);
    // ٱѡI/EparallelʸǤɡ
    int		b_width;
    int		b_heigh;

    int*	host_cnt;
    int*	wait_cnt;
    vs_io_buf**	  io_buf;
    vs_reqgrp*	send_buf;

    T		GetReq(int x, int y);
    T		SetReq(T val);

    // ֽ񤭹ѡ㳰Ū
    vs_write	wbuf;

  public:
    int		id;

    vs_data*	info;
    T*		dt;
    //T**          dt2;
    vsImage();
    vsImage(int width, int heigh, int def = 0);
    vsImage(vsImage<int>*   orig, int def);
    vsImage(vsImage<FLOAT>* orig, int def);
   ~vsImage();

#define _VS_OPERATE_2D(OP)				\
    if(w_chk){						\
	dt[ly * info->local->width + lx] OP val;	\
        /*dt2[ly][lx] OP val;*/                             \
    }else						\
	SetReq(val);					\
    return val

    inline T  operator  =(T val){ _VS_OPERATE_2D(=);  };
    inline T  operator +=(T val){ _VS_OPERATE_2D(+=); };
    inline T  operator -=(T val){ _VS_OPERATE_2D(-=); };
    inline T  operator *=(T val){ _VS_OPERATE_2D(*=); };
    inline T  operator /=(T val){ _VS_OPERATE_2D(/=); };

#undef  _VS_OPERATE_2D

    inline T  		 vs_ck (int x, int y);

    inline T		 vs_rd (int x, int y);
    inline T		 vs_rde(int x, int y);
    inline T		 vs_rdc(int x, int y);

    inline vsImage<T>&   vs_wt (int x, int y);
    inline vsImage<T>&   vs_wte(int x, int y);
    inline vsImage<T>&   vs_wtc(int x, int y);

    inline vsImage<T>&   vs_rw (int x, int y);
    inline vsImage<T>&	 vs_rwe(int x, int y);
    inline vsImage<T>&   vs_rwc(int x, int y);

    void	ImgCopy(vsImage<int>*   src);
    void	ImgCopy(vsImage<FLOAT>* src);

};

#include	"vsImage_const.h"
#include 	"vsImage_io.h"
#include	"vsImage_comm.h"

#endif
