%{
/******************************************************

 pp.y
 moduleΤΥץץåʹʸ
 ******************************************************/
#include <stdio.h>
#include <stdlib.h>

#define YYLMAX		300

#define MAX_VAL_N	256
#define MAX_CHAR	256

/* ѿơ֥ */
int  w_num = 1;
int  windex[MAX_VAL_N]		 = {0};
char wtable[MAX_VAL_N][MAX_CHAR] = {0};

#define MAX_STACK	8

/* ɥ쥹黻ͥȥå */
int  stk_cnt = 0;
struct {
    int pnt;
    int cnt;
} stack[MAX_STACK];

int 	now_pnt;		/* ɤ߽Ф񤭹ߤѹ뤿 */
int	now_cnt  = -1;		/* ] бդϤ뤿     */
int	now_cnt2 = -1;		/* ) бդϡcommѡ   */
int	now_cnt3 =  0;		/* commΰο򥫥         */
int	ctr_flg;

/* ɥ쥹黻ѥХåե   */
char store[MAX_CHAR];
char phase[MAX_CHAR];

/* ⥸塼̾񤭽Фե */
char* user_name;
char  module_name[MAX_CHAR];
FILE* module_file;

extern int	yyerror(char* s);
extern int	yylex();
extern FILE*	yyout;

void	pp_push(int, int);
void	pp_pop (int*, int*);
%}
%union {
    int		id;
    char*	str;
}

%token	<id>	MODULE ICUB FCUB ICUB_O FCUB_O
%token	<id>	IIMG FIMG IIMG_O FIMG_O IVAL FVAL IVAL_O FVAL_O ARROW NOP
%token  <id>    COMM_STAT
%token	<str>	VS_VAL VS_IMG VS_CUB NO_VAL READ_OP WRITE_OP RWRITE_OP STR


%token		LP  RP	/*  ( )  */
%token		LC  RC	/*  { }  */
%token		LB  RB	/*  [ ]  */
%token		LLB RRB	/* [[ ]] */
%token		SM  CM	/*  ; ,  */
%token		CN	/*  :    */
%token		RB_DUMMY
%token		RP_DUMMY	/* RBξỌ̇̄礤դˤʤ */

/* ꤢϸ */

%%
program	: value_check_list
        ;
value_check_list
	: 
        | value_check_list value_check
	;
value_check
	: module_declare
	| value_declare
	| relation_access
	| absolution_access
	| pointer_access		/* ݥ󥿤ȤƤΰƤ */
        | comm_statement
	| other_word
	;
/* ------------------ ⥸塼 ------------------ */
module_declare
        : MODULE NO_VAL {
	    fprintf(yyout,"extern \"C\" {\n\tvs_module %s();\n}\n\n", $2);
	    fprintf(yyout,"vs_module\n");
	    fprintf(yyout,"%s", $2);

	    /* setenv POSIX̵ΤǤȤꤢ */
	    user_name = getenv("USER");
	    sprintf(module_name,"/tmp/_module_name_at_%s.txt",user_name);

	    if(!(module_file = fopen(module_name, "w"))) {
		fprintf(stderr,"Cannot create name file.\n");
		return 0;
	    }
	    fprintf(module_file,"%s", $2);
	    fclose(module_file);
	}
        LP {
	    fprintf(yyout,"()\n{\n");
	}
	value_declare_list RP LC
        ;
value_declare_list
        :
	| value_declare {
	    fprintf(yyout,"();\n");
	}
	| value_declare {
	    fprintf(yyout,"();\n");
	} CM value_declare_list
	;
value_declare
        : ICUB NO_VAL {
	    windex[w_num] = VS_CUB;
	    strcpy(wtable[w_num++], $2);
	    fprintf(yyout,"\tiCube* %s = new iCube",$2);
	 }
	| FCUB NO_VAL {
	    windex[w_num] = VS_CUB;
	    strcpy(wtable[w_num++], $2);
	    fprintf(yyout,"\tfCube* %s = new fCube",$2);
	 }
	| ICUB READ_OP NO_VAL {		/* ݥ󥿤ȤƤ */
	    windex[w_num] = VS_CUB;
	    strcpy(wtable[w_num++], $2);
	    fprintf(yyout,"\tiCube* %s",$2);
	 }
	| FCUB READ_OP NO_VAL {		/* ݥ󥿤ȤƤ */
	    windex[w_num] = VS_CUB;
	    strcpy(wtable[w_num++], $2);
	    fprintf(yyout,"\tfCube* %s",$2);
	 }
        | ICUB_O NO_VAL {
	    windex[w_num] = VS_CUB;
	    strcpy(wtable[w_num++], $2);
	    fprintf(yyout,"\tiCube_opt* %s = new iCube_opt",$2);
	 }
	| FCUB_O NO_VAL {
	    windex[w_num] = VS_CUB;
	    strcpy(wtable[w_num++], $2);
	    fprintf(yyout,"\tfCube_opt* %s = new fCube_opt",$2);
	 }
	| ICUB_O READ_OP NO_VAL {		/* ݥ󥿤ȤƤ */
	    windex[w_num] = VS_CUB;
	    strcpy(wtable[w_num++], $2);
	    fprintf(yyout,"\tiCube_opt* %s",$2);
	 }
	| FCUB_O READ_OP NO_VAL {		/* ݥ󥿤ȤƤ */
	    windex[w_num] = VS_CUB;
	    strcpy(wtable[w_num++], $2);
	    fprintf(yyout,"\tfCube_opt* %s",$2);
	 } 
	| IIMG NO_VAL {
	    windex[w_num] = VS_IMG;
	    strcpy(wtable[w_num++], $2);
	    fprintf(yyout,"\tiImage* %s = new iImage",$2);
	 }
	| FIMG NO_VAL {
	    windex[w_num] = VS_IMG;
	    strcpy(wtable[w_num++], $2);
	    fprintf(yyout,"\tfImage* %s = new fImage",$2);
	 }
	| IIMG READ_OP NO_VAL {		/* ݥ󥿤ȤƤ */
	    windex[w_num] = VS_IMG;
	    strcpy(wtable[w_num++], $2);
	    fprintf(yyout,"\tiImage* %s",$2);
	 }
	| FIMG READ_OP NO_VAL {		/* ݥ󥿤ȤƤ */
	    windex[w_num] = VS_IMG;
	    strcpy(wtable[w_num++], $2);
	    fprintf(yyout,"\tfImage* %s",$2);
	 }
	| IIMG_O NO_VAL {
	    windex[w_num] = VS_IMG;
	    strcpy(wtable[w_num++], $2);
	    fprintf(yyout,"\tiImage_opt* %s = new iImage_opt",$2);
	 }
	| FIMG_O NO_VAL {
	    windex[w_num] = VS_IMG;
	    strcpy(wtable[w_num++], $2);
	    fprintf(yyout,"\tfImage_opt* %s = new fImage_opt",$2);
	 }
	| IIMG_O READ_OP NO_VAL {	/* ݥ󥿤ȤƤ */
	    windex[w_num] = VS_IMG;
	    strcpy(wtable[w_num++], $2);
	    fprintf(yyout,"\tiImage_opt* %s",$2);
	 }
	| FIMG_O READ_OP NO_VAL {	/* ݥ󥿤ȤƤ */
	    windex[w_num] = VS_IMG;
	    strcpy(wtable[w_num++], $2);
	    fprintf(yyout,"\tfImage_opt* %s",$2);
	 }
	| IVAL NO_VAL {
	    windex[w_num] = VS_VAL;
	    strcpy(wtable[w_num++], $2);
	    fprintf(yyout,"\tivalue* %s = new ivalue", $2);
	 }
	| FVAL NO_VAL {
	    windex[w_num] = VS_VAL;
	    strcpy(wtable[w_num++], $2);
	    fprintf(yyout,"\tfvalue* %s = new fvalue",$2);
	 }
	| IVAL READ_OP NO_VAL {		/* ݥ󥿤ȤƤ */
	    windex[w_num] = VS_VAL;
	    strcpy(wtable[w_num++], $2);
	    fprintf(yyout,"\tivalue* %s",$2);
	 }
	| FVAL READ_OP NO_VAL {		/* ݥ󥿤ȤƤ */
	    windex[w_num] = VS_VAL;
	    strcpy(wtable[w_num++], $2);
	    fprintf(yyout,"\tfvalue* %s",$2);
	 }
	| IVAL_O NO_VAL {
	    windex[w_num] = VS_VAL;
	    strcpy(wtable[w_num++], $2);
	    fprintf(yyout,"\tivalue_opt* %s = new ivalue_opt", $2);
	 }
	| FVAL_O NO_VAL {
	    windex[w_num] = VS_VAL;
	    strcpy(wtable[w_num++], $2);
	    fprintf(yyout,"\tfvalue_opt* %s = new fvalue_opt",$2);
	 }
	| IVAL_O READ_OP NO_VAL {		/* ݥ󥿤ȤƤ */
	    windex[w_num] = VS_VAL;
	    strcpy(wtable[w_num++], $2);
	    fprintf(yyout,"\tivalue_opt* %s",$2);
	 }
	| FVAL_O READ_OP NO_VAL {		/* ݥ󥿤ȤƤ */
	    windex[w_num] = VS_VAL;
	    strcpy(wtable[w_num++], $2);
	    fprintf(yyout,"\tfvalue_opt* %s",$2);
	 }
        ;




/* ---------------- VIOSѿؤΥ() ---------------- */
relation_access
        /* 3 */
        : VS_CUB LB {
	    ctr_flg = 0;
	    sprintf(phase,"%s->", wtable[$<id>1]);
	    now_pnt = strlen(phase); now_cnt = 1;
            strcat(phase,"vs_rd (_vs_x");
	} relation_list RB LB {
	    now_cnt = 1; strcat(phase,",_vs_y");
	} relation_list RB LB {
	    now_cnt = 1; strcat(phase,",_vs_z");
	} relation_list RB {
	    strcat(phase,") "); --now_cnt;
	} end_paragraph {
	    if(!ctr_flg)	phase[now_pnt+5] = 'c';
	    fprintf(yyout,"%s", phase);
	}

        /* 2 */
        | VS_IMG LB {
	    ctr_flg = 0;
	    sprintf(phase,"%s->", wtable[$<id>1]);
            now_pnt = strlen(phase); now_cnt = 1;
            strcat(phase,"vs_rd (_vs_x");
	} relation_list RB LB {
	    now_cnt = 1; strcat(phase,",_vs_y");
	} relation_list RB {
	    strcat(phase,") "); --now_cnt;
	} end_paragraph {
	    if(!ctr_flg)	phase[now_pnt+5] = 'c';
	    fprintf(yyout,"%s", phase);
	}

        /* 1 */
        | VS_VAL LB {
	    ctr_flg = 0;
	    sprintf(phase,"%s->", wtable[$<id>1]);
            now_pnt = strlen(phase); now_cnt = 1;
            strcat(phase,"vs_rd (_vs_x");
	} relation_list RB {
	    strcat(phase,") "); --now_cnt;
	} end_paragraph {
	    if(!ctr_flg)	phase[now_pnt+5] = 'c';
	    fprintf(yyout,"%s", phase);
	}
        ;


/* ------------------- NESTɥ쥹黻ξ ------------------- */
relation_access_nested
       
        : VS_CUB LB {		       /******   3   *******/
	    ctr_flg = 0;
	    pp_push(now_pnt, now_cnt); /* ¸ */

 	    strcat(phase,wtable[$<id>1]); strcat(phase,"->");
	    now_pnt = strlen(phase); now_cnt = 1;
            strcat(phase,"vs_rd (_vs_x");
	} relation_list RB LB {
	    now_cnt = 1; strcat(phase,",_vs_y");
	} relation_list RB LB {
	    now_cnt = 1; strcat(phase,",_vs_z");
	} relation_list RB {
	    strcat(phase,") ");
	    if(!ctr_flg)	phase[now_pnt+5] = 'c';

	    pp_pop(&now_pnt, &now_cnt);
	    ++ctr_flg;
	}

        | VS_IMG LB {		       /******   2   *******/
	    ctr_flg = 0;
	    pp_push(now_pnt, now_cnt);

	    strcat(phase,wtable[$<id>1]); strcat(phase,"->");
	    now_pnt = strlen(phase); now_cnt = 1;
            strcat(phase,"vs_rd (_vs_x");
	} relation_list RB LB {
	    now_cnt = 1; strcat(phase,",_vs_y");
	} relation_list RB {
	    strcat(phase,") ");
	    if(!ctr_flg)	phase[now_pnt+5] = 'c';

	    pp_pop(&now_pnt, &now_cnt);
	    ++ctr_flg;
	}

        | VS_VAL LB {		       /******   1   *******/
	    ctr_flg = 0;
	    pp_push(now_pnt, now_cnt);

	    strcat(phase,wtable[$<id>1]); strcat(phase,"->");
	    now_pnt = strlen(phase); now_cnt = 1;
            strcat(phase,"vs_rd (_vs_x");
	} relation_list RB {
	    strcat(phase,") ");
	    if(!ctr_flg)	phase[now_pnt+5] = 'c';

	    pp_pop(&now_pnt, &now_cnt);
	    ++ctr_flg;
	}
        ;


/* ---------------- VIOSѿؤΥ() ---------------- */

/* -----  ɥ쥹Ѵѿؿ֤뤳  ----- */
absolution_access
        /* 3 */
        : VS_CUB  {
	    sprintf(phase,"%s->", wtable[$<id>1]);
            now_pnt = strlen(phase); now_cnt = 1;
            strcat(phase,"vs_rd (g2l_x(");
	    strcat(phase, wtable[$<id>1]);
	    strcat(phase,",");
	} absolution_list {
	    strcat(phase, "),g2l_y(");
	    strcat(phase, wtable[$<id>1]);
	    strcat(phase,",");
	    now_cnt = 1;
	} absolution_list {
	    strcat(phase, "),g2l_z(");
	    strcat(phase, wtable[$<id>1]);
	    strcat(phase,",");
	    now_cnt = 1;
	} absolution_list {
	    strcat(phase,"))"); --now_cnt;
	} end_paragraph { fprintf(yyout,"%s", phase); }

        /* 2 */
	| VS_IMG  {
	    sprintf(phase,"%s->", wtable[$<id>1]);
            now_pnt = strlen(phase); now_cnt = 1;
            strcat(phase,"vs_rd (g2l_x(");
	    strcat(phase, wtable[$<id>1]);
	    strcat(phase,",");

	} absolution_list {
	    strcat(phase, "),g2l_y(");
	    strcat(phase, wtable[$<id>1]);
	    strcat(phase,",");
	    now_cnt = 1;
	} absolution_list {
	    strcat(phase, "))"); --now_cnt;
	} end_paragraph { fprintf(yyout,"%s", phase); }

        /* 1 */
	| VS_VAL {
	    sprintf(phase,"%s->", wtable[$<id>1]);
            now_pnt = strlen(phase); now_cnt = 1;
            strcat(phase,"vs_rd (g2l_x(");
	    strcat(phase, wtable[$<id>1]);
	    strcat(phase,",");
	} absolution_list {
	    strcat(phase,"))"); --now_cnt;
	} end_paragraph { fprintf(yyout,"%s", phase); }
	;

absolution_access_nested

        : VS_CUB  {		       /******   3   *******/
	    pp_push(now_pnt, now_cnt);

	    sprintf(phase,"%s->", wtable[$<id>1]);
            now_pnt = strlen(phase); now_cnt = 1;
            strcat(phase,"vs_rd (g2l_x(");
	    strcat(phase, wtable[$<id>1]);
	    strcat(phase,",");
	} absolution_list {
	    strcat(phase, "),g2l_y(");
	    strcat(phase, wtable[$<id>1]);
	    strcat(phase,",");
	    now_cnt = 1;
	} absolution_list {
	    strcat(phase, "),g2l_z(");
	    strcat(phase, wtable[$<id>1]);
	    strcat(phase,",");
	    now_cnt = 1;
	} absolution_list {
	    strcat(phase,"))");

	    pp_pop(&now_pnt, &now_cnt);
	} end_paragraph { fprintf(yyout,"%s", phase); }

	| VS_IMG  {		       /******   2   *******/
	    pp_push(now_pnt, now_cnt);

	    sprintf(phase,"%s->", wtable[$<id>1]);
            now_pnt = strlen(phase); now_cnt = 1;
            strcat(phase,"vs_rd (g2l_x(");
	    strcat(phase, wtable[$<id>1]);
	    strcat(phase,",");
	} absolution_list {
	    strcat(phase, "),g2l_y(");
	    strcat(phase, wtable[$<id>1]);
	    strcat(phase,",");
	    now_cnt = 1;
	} absolution_list {
	    strcat(phase, "))");

	    pp_pop(&now_pnt, &now_cnt);
	} end_paragraph { fprintf(yyout,"%s", phase); }

	| VS_VAL {		       /******   1   *******/
	    pp_push(now_pnt, now_cnt);

	    sprintf(phase,"%s->", wtable[$<id>1]);
            now_pnt = strlen(phase); now_cnt = 1;
            strcat(phase,"vs_rd (g2l_x(");
	    strcat(phase, wtable[$<id>1]);
	    strcat(phase,",");
	} absolution_list {
	    strcat(phase,"))");

	    pp_pop(&now_pnt, &now_cnt);
	} end_paragraph { fprintf(yyout,"%s", phase); }
	;



/*--------- VIOSѿˤ륢ˡ -------- */

absolution_list
        : LLB relation_list RRB
        ;
relation_list
        : /* 0ʾη֤ */
        | relation_word { ++ctr_flg; } relation_list
        ;
relation_word
        : LP                   { strcat(phase,"(");   }
	| RP                   { strcat(phase,")");   }
	| LC                   { strcat(phase,"{");   }
	| RC                   { strcat(phase,"}");   }
        | LB                   { strcat(phase,"[");   ++now_cnt; }
        | RB_DUMMY             { strcat(phase,"]");   }
        | READ_OP              { strcat(phase,store); }
        | WRITE_OP             { strcat(phase,store); }
        | NO_VAL               { strcat(phase,$1);    }
        | relation_access_nested
        | absolution_access_nested
        | pointer_access_nested
        ;

end_paragraph
        : SM        { strcat(phase,";"); }
	| RP        { if(--now_cnt2) strcat(phase,")"); }
	| CM        { strcat(phase,","); }
	| READ_OP   { strcat(phase, store);}
        | WRITE_OP  { strcat(phase, store); phase[now_pnt+3] = 'w';
		                            phase[now_pnt+4] = 't'; }
        | RWRITE_OP { strcat(phase, store); phase[now_pnt+4] = 'w'; }
        ;


/* --------------- ݥ󥿤б뤿γĥ -------------- */
pointer_access
        : VS_CUB end_term {
	    if($<id>2 == '-') {
		fprintf(yyout,"%s->", wtable[$<id>1]);
	    } else {
		fprintf(yyout,"%s%c", wtable[$<id>1],$<id>2);
	    }
	}
        | VS_IMG end_term {
	    if($<id>2 == '-') {
		fprintf(yyout,"%s->", wtable[$<id>1]);
	    } else {
		fprintf(yyout,"%s%c", wtable[$<id>1],$<id>2);
	    }
	}
        | VS_VAL end_term {
	    if($<id>2 == '-') {
		fprintf(yyout,"%s->", wtable[$<id>1]);
	    } else {
		fprintf(yyout,"%s%c", wtable[$<id>1],$<id>2);
	    }
	}
pointer_access_nested
        : VS_CUB end_term {
	    int len;
	    if($<id>2 == '-') {
		strcat(phase, wtable[$<id>1]);
		strcat(phase, "->");
	    } else {
	        strcat(phase, wtable[$<id>1]);
		len = strlen(phase);
		phase[len] = $<id>2;
		phase[len+1] = '\0';
	    }
	}
        | VS_IMG end_term {
	    int len;
	    if($<id>2 == '-') {
		strcat(phase, wtable[$<id>1]);
		strcat(phase, "->");
	    } else {
	        strcat(phase, wtable[$<id>1]);
		len = strlen(phase);
		phase[len] = $<id>2;
		phase[len+1] = '\0';
	    }
	}
        | VS_VAL end_term {
	    int len;
	    if($<id>2 == '-') {
		strcat(phase, wtable[$<id>1]);
		strcat(phase, "->");
	    } else {
	        strcat(phase, wtable[$<id>1]);
		len = strlen(phase);
		phase[len] = $<id>2;
		phase[len+1] = '\0';
	    }
	}
end_term
        : SM    { $<id>$ = ';'; }
	| RP    { $<id>$ = ')'; }
	| CM    { $<id>$ = ','; }
        | ARROW { $<id>$ = '-'; }
	;


/* ------------- ޤǤϤҤȤޤλȤɤ ------------- */

comm_statement
        : COMM_STAT  {
	    now_cnt2 = 1; now_cnt3 = 1;
	    fprintf(yyout,"%s(", store);
	} LP
        comm_argment_list SM {
	    switch(now_cnt3) {
	      case 2:
		fprintf(yyout,",_vs_x);");
		break;
	      case 3:
		fprintf(yyout,",_vs_x,_vs_y);");
		break;
	      default:
		fprintf(yyout,",_vs_x,_vs_y,_vs_z);");
	    }
	    now_cnt2 = -1;
	}

comm_argment_list
        : /* ɬפ̵ߡ */
        | comm_argment comm_argment_list
        ;
comm_argment
        : LP		{ fprintf(yyout,"("); ++now_cnt2; }
	| RP 		{ if(--now_cnt2) fprintf(yyout,")"); }
        | CM 		{ fprintf(yyout,","); if(now_cnt2 == 1)  ++now_cnt3; }
        | LB 		{ fprintf(yyout,"["); }
        | RB 		{ fprintf(yyout,"]"); }
        | ARROW 	{ fprintf(yyout,"->"); }
        | NOP           { fprintf(yyout,"%s",store); }
        | READ_OP 	{ fprintf(yyout,"%s",store); }
        | WRITE_OP	{ fprintf(yyout,"%s",store); }
        |RWRITE_OP	{ fprintf(yyout,"%s",store); }
        | STR     	{ fprintf(yyout,"%s",store); }
        | NO_VAL  	{ fprintf(yyout,"%s", $1);   }
	| relation_access
	| absolution_access
        ;




/* ------------ ¾ yacc򤴤ޤ --------------- */
other_word
        : LP { fprintf(yyout,"("); }
	| RP { fprintf(yyout,")"); }
	| LC { fprintf(yyout,"{"); }
	| RC { fprintf(yyout,"}"); }
        | CM { fprintf(yyout,","); }
        | CN { fprintf(yyout,":"); }
        | SM { fprintf(yyout,";"); }
        | LB { fprintf(yyout,"["); }
        | RB { fprintf(yyout,"]"); }
        | ARROW { fprintf(yyout,"->"); }
        | NOP           { fprintf(yyout,"%s",store); }
        | READ_OP { fprintf(yyout,"%s",store); }
        | WRITE_OP{ fprintf(yyout,"%s",store); }
        |RWRITE_OP{ fprintf(yyout,"%s",store); }
        | STR     { fprintf(yyout,"%s",store); }
        | NO_VAL  { fprintf(yyout,"%s", $1);   }
%%
#include "pp1.yy.c"

int
yyerror(char* s){
  fprintf(stderr , "%s:%d\n",s, line);
}

void
pp_push(int pnt, int cnt)
{
    stack[stk_cnt].pnt = pnt;
    stack[stk_cnt].cnt = cnt;
    ++stk_cnt;
}

void
pp_pop(int* pnt, int* cnt)
{
    --stk_cnt;
    *pnt = stack[stk_cnt].pnt;
    *cnt = stack[stk_cnt].cnt;
}
