/**************************************************
  snake.cc
  ͡
***************************************************/
#include <math.h>

#define TIMES	40

// §˴Ťƥͥ륮ؿνŤߤȤʤ
#define MU_FIELD       1.
#define MU_ANGLE       1.
#define MU_DISTANCE    1.
#define MU_MOVE        1.


#define NO_USE	-1

// ΤĤʤ餫ˤ륨ͥ륮׻
// ȽŤʤäƤ0֤
float
CalcAngle(int pre_x, int pre_y, int x,int y,int next_x,int next_y)
{
    int Vec1_x,Vec1_y;   // preȤδ֤˰٥ȥʬ
    float Vec1_size;     // Ʊ礭
    
    int Vec2_x,Vec2_y;   // nextȤδ֤˰٥ȥʬ
    float Vec2_size;     // Ʊ礭
    
    float I_product;     // 2ĤΥ٥ȥΤʤ
    float CosTheta;      // 2ĤΥ٥ȥΤʤ٤Υ
    

    // 2Ȥδ֤˰٥ȥ礭׻
    Vec1_x = x - pre_x;
    Vec1_y = y - pre_y;
    Vec1_size = sqrt((float)(Vec1_x*Vec1_x + Vec1_y*Vec1_y));

    if(Vec1_size == 0.)	return 0.;

    Vec2_x = x - next_x;
    Vec2_y = y - next_y;
    Vec2_size = sqrt((float)(Vec2_x*Vec2_x + Vec2_y*Vec2_y));

    if(Vec2_size == 0.) return 0.;

    // Ѥȥͤλ
    I_product = (float)(Vec1_x * Vec2_x + Vec1_y * Vec2_y);
    CosTheta  = I_product / (Vec1_size * Vec2_size);
    
    return ((CosTheta > 0)? CosTheta : CosTheta/2);
}


// ֤εΥ褦Ȥ륨ͥ륮׻
float
CalcDist(int pre_x, int pre_y, int x, int y, int next_x,int next_y)
{
    int Vec1_x,Vec1_y;   // preȤδ֤˰٥ȥʬ
    float Vec1_size;     // Ʊ礭
    
    int Vec2_x,Vec2_y;   // nextȤδ֤˰٥ȥʬ
    float Vec2_size;     // Ʊ礭
    
    // 2Ȥδ֤˰٥ȥ礭׻
    Vec1_x = x-pre_x;
    Vec1_y = y-pre_y;
    Vec1_size = sqrt((float)(Vec1_x*Vec1_x + Vec1_y*Vec1_y));
    
    Vec2_x = x-next_x;
    Vec2_y = y-next_y;
    Vec2_size = sqrt((float)(Vec2_x*Vec2_x + Vec2_y*Vec2_y));
    
    // 2ĤΥ٥ȥ礭κ
    return fabs(Vec1_size - Vec2_size)/(Vec1_size + Vec2_size);
}


// ߤγ¦˰ư褦Ȥ륨ͥ륮ʱߤĥ
// ȽŤʤäƤ0֤
float
CalcMove(int pre_x,int pre_y, int new_x, int new_y, int old_x, int old_y)
{
    int Vec1_x,Vec1_y;   // newȤδ֤˰٥ȥʬ
    float Vec1_size;     // Ʊ礭
    
    int Vec2_x,Vec2_y;   // oldȤδ֤˰٥ȥʬ
    float Vec2_size;     // Ʊ礭
    
    float O_product;     // 2ĤΥ٥ȥΤʤ
    float SinTheta;      // 2ĤΥ٥ȥΤʤ٤Υ
    
    // 2Ȥδ֤˰٥ȥ礭׻ޤ
    Vec1_x = new_x-pre_x;
    Vec1_y = new_y-pre_y;
    Vec1_size = sqrt((float)(Vec1_x*Vec1_x + Vec1_y*Vec1_y));

    if(Vec1_size == 0.) return 0.;
    
    Vec2_x = old_x-pre_x;
    Vec2_y = old_y-pre_y;
    Vec2_size = sqrt((float)(Vec2_x*Vec2_x + Vec2_y*Vec2_y));

    if(Vec2_size == 0.) return 0.;
    
    // Ѥȥ
    O_product = (float)(Vec1_x * Vec2_y - Vec1_y * Vec2_x);
    SinTheta  = O_product / (Vec1_size * Vec2_size);
    
    return -SinTheta;
}


// ͡ -------------------------------------------------
int
SelectNewPoint(int neighbor[3][3], \
	       int pre_x,int pre_y, int* x,int* y, int next_x,int next_y)
{
    int   old_x,old_y;    
    float Efield,Eangle,Edist,Emove;
    float Eall,Eall_min = 300.;  	// ͥ륮¤ȤκǾ

    old_x = *x;
    old_y = *y;
    // ˵8սȸΰ֤ΤǺǤͥ륮㤤֤õ
     for(int j = old_y - 1; j < old_y + 2; j++){
	for(int i = old_x - 1; i < old_x + 2; i++){

	    if(neighbor[i-old_x+1][j-old_y+1] != NO_USE){

		// ֥ͥ륮
		Efield = (float)neighbor[i-old_x+1][j-old_y+1] * MU_FIELD;

		Eangle = CalcAngle(pre_x,pre_y,i,j,next_x,next_y) \
		                                             * MU_ANGLE;
		Edist  = CalcDist(pre_x,pre_y,i,j,next_x,next_y)  \
		                                             * MU_DISTANCE;
		Emove  = CalcMove(pre_x,pre_y,i,j,old_x,old_y)  \
		                                             * MU_MOVE;
		Eall = Efield + Eangle + Edist + Emove;
	
		if(Eall < Eall_min){
		    Eall_min = Eall; *x = i; *y = j;
		}
	    }
	}
    }
    return 1;
}


// VIOSΥ⥸塼Ȥ -------------------------------


vs_module
snake(iImage edge, ivalue circle_x, ivalue circle_y)
{
    for(int times =0; times < TIMES; times++) {

	parallel(lx) {

	    // åΤᡤɸ륢ɥ쥹Ѵ
	    int x = g2l_x(edge, circle_x[]);
	    int y = g2l_y(edge, circle_y[]);

	    // ôϰϤ
	    if((x >= local_min_x(edge)) && (x <= local_max_x(edge)) && \
	       (y >= local_min_y(edge)) && (y <= local_max_y(edge))) { 
		
		int pre_x, pre_y, next_x, next_y;
		int neighbor[3][3];

		if(!lx) {
		    pre_x  = circle_x[[orig_width(circle_x)-1]];
		    pre_y  = circle_y[[orig_width(circle_y)-1]];
		    next_x = circle_x[+1];
		    next_y = circle_y[+1];

		} else if(lx == (orig_width(circle_x) - 1)) {
		    pre_x  = circle_x[-1];
		    pre_y  = circle_y[-1];
		    next_x = circle_x[[0]];
		    next_y = circle_y[[0]];
		} else {
		    pre_x  = circle_x[-1];
		    pre_y  = circle_y[-1];
		    next_x = circle_x[+1];
		    next_y = circle_y[+1];
		}
		x = circle_x[];
		y = circle_y[];

		// ܺɸβǤȡμ8˵βǤμФ
		for(int j=-1; j<2; j++)
		    for(int i=-1; i<2; i++)
			if(((y+j)>0) && ((y+j)< orig_heigh(edge)) && \
			   ((x+i)>0) && ((x+i)< orig_width(edge))) {

			    neighbor[i+1][j+1] = edge[[x+i]][[y+j]];
			} else {
			    neighbor[i+1][j+1] = NO_USE;
			}

		// ͥ륮η׻򤷤ƿʥݥȤõ
		SelectNewPoint(neighbor, pre_x, pre_y, \
					            &x, &y, next_x, next_y);

		// ѿͤꤲ(å̤)
		vsVote(circle_x, lx, x);
		vsVote(circle_y, lx, y);
	    }
	}
	// ׻ɼ̤򽸷פ
	vsUnion(circle_x, vsAGGRIGATE);
	vsUnion(circle_y, vsAGGRIGATE);

	if(!((times+1) % 10))
	    fprintf(stderr,"%d times passed.\n", times+1);
    }



    // ̲  ----------------------------------------------
    parallel(lx, ly) {
	edge[][] = 255;
    }

    parallel(lx) {
	// åΤɸǤΥɥ쥹Ѵ
	int x = g2l_x(edge, circle_x[]);
	int y = g2l_y(edge, circle_y[]);

	// ôϰϤ
	if((x >= local_min_x(edge)) && (x <= local_max_x(edge)) && \
	   (y >= local_min_y(edge)) && (y <= local_max_y(edge))) { 

	    for(int j=-1; j<2; j++)
		for(int i=-1; i<2; i++)
		    edge[[circle_x[]+i]][[circle_y[]+j]] = 0;
	}
    }
}
