/********************************************************************
  ip_table.h
  ѿδԤʤΥեǴ
*********************************************************************/
#ifndef __IP_TABLE_H
#define __IP_TABLE_H

#include "ip_struct.h"

class IpTable
{
    vs_data begin;

    // λ ؿ
    void delTbl(vs_data* ptr)
    {
	if(ptr->next != NULL) delTbl(ptr->next);

	// ǤȺι¤˹礦褦˽
	switch(ptr->type) {
	  case iIMG :
	  case iCUB :
	    delete   ptr->orig;
	    delete   ptr->local;
	  case INT :
	    delete[] ptr->div_info;
	    delete[] (int*)ptr->val;
	    break;
	  case fIMG :
	  case fCUB :
	     delete   ptr->orig;
	    delete   ptr->local;
	  default :
	    delete[] ptr->div_info;
	    delete[] (FLOAT*)ptr->val;
	}
	delete ptr;
    };

  public:
     IpTable(){
	 begin.id   = -1;
	 begin.next = NULL;
     };
    ~IpTable(){
	if(begin.next != NULL) delTbl(begin.next);
    };

    vs_data*  regist(vs_data* ptr);
    vs_data*     get(int id)
    {
	for(vs_data* ptr = &begin; ptr->next != NULL; ptr = ptr->next)
	    if(ptr->next->id == id) return ptr->next;
	return NULL;
    };
};

extern IpTable  ip_table;

#endif
