/*********************************************************************
  maketable.h
  $B%5%$%/%j%C%/J,3dMQ$N%i%$%V%i%j(B
*********************************************************************/
#include "om_struct.h"
#include "vios_run.h"
#include "om_table.h"

int* gxtable_cyc(vs_data* data, int id, int IS){//$B%5%$%/%j%C%/$N;~MQ!#2~NI$NI,MW$"$j!#:#$O(BCOLCYC$B$@$1$J$N$G(B
  int host = exec_info.host_num;
  int x = data->div_hint.x_divide;
  int c = data->dim->cache;
  int width = data->dim->width;
  int *table = new int[width];
  int n,index;

  for(int i=0;i<width;i++){
    if(id+1 == host){
      n = (i - c)/(host*x);
    } else {
      n = (i + c)/(host*x);
    }
    if(n == 0){
      index = -(id*x) + IS;
    } else {
      index = -(id*x + n*host*x - c) + (x+2*c)*n - c + IS;
    }
    table[i] = i + index;
    //fprintf(stderr,"%d->%d ",i,table[i]);
  }
  return(table);
}

int* gxtable(vs_data* data, int id){
  int width = data->dim->width;
  int *table = new int[width];
  if(data->dtype == dALL){
    for(int i=0;i<width;i++){
      table[i] = i;
    }
    return(table);
  }
}
