/********************************************************************
  readdlib.c
  VIOS$BMQ(B Read $B=hM}4XO"4X?t(B
*********************************************************************/
#include "vios_lib.h"

void iSave(char* path, int x_size, int* data){
  int i;
  FILE *file;
  if((file = fopen(path,"w")) == NULL){
    puts("File open error");
    exit(0);
  }
  for(i=0;i<x_size;i++){
    fprintf(file,"%d",data[i]);
    if((i+1)%10 == 0){
      fprintf(file,"\n");
    } else {
      fprintf(file," ");
    }
  }
  fclose(file);
}

void fSave(char* path, int x_size, FLOAT* data){
  int i;
  FILE *file;
  if((file = fopen(path,"w")) == NULL){
    puts("File open error");
    exit(0);
  }
  for(i=0;i<x_size;i++){
    fprintf(file,"%f",data[i]);
    if((i+1)%10 == 0){
      fprintf(file,"\n");
    } else {
      fprintf(file," ");
    }
  }
  fclose(file);
}

void i2Save(char* path, int x_size, int y_size, int* data){
  int i;
  FILE *file;
  if((file = fopen(path,"w")) == NULL){
    puts("File open error");
    exit(0);
  }
  for(i=0;i<x_size * y_size;i++){
    fprintf(file,"%d",data[i]);
    if((i+1)%x_size == 0){
      fprintf(file,"\n");
    } else {
      fprintf(file," ");
    }
  }
  fclose(file);
}

void f2Save(char* path, int x_size, int y_size, FLOAT* data){
  int i;
  FILE *file;
  if((file = fopen(path,"w")) == NULL){
    puts("File open error");
    exit(0);
  }
  for(i=0;i<x_size * y_size;i++){
    fprintf(file,"%f",data[i]);
    if((i+1)%x_size == 0){
      fprintf(file,"\n");
    } else {
      fprintf(file," ");
    }
  }
  fclose(file);
}

void i3Save(char* path, int x_size, int y_size, int z_size, int* data){
  int i;
  FILE *file;
  if((file = fopen(path,"w")) == NULL){
    puts("File open error");
    exit(0);
  }
  for(i=0;i<x_size * y_size * z_size;i++){
    fprintf(file,"%d",data[i]);
    if((i+1)%x_size == 0){
      fprintf(file,"\n");
    } else {
      fprintf(file," ");
    }
  }
  fclose(file);
}

void f3Save(char* path, int x_size, int y_size, int z_size, FLOAT* data){
  int i;
  FILE *file;
  if((file = fopen(path,"w")) == NULL){
    puts("File open error");
    exit(0);
  }
  for(i=0;i<x_size * y_size * z_size;i++){
    fprintf(file,"%f",data[i]);
    if((i+1)%x_size == 0){
      fprintf(file,"\n");
    } else {
      fprintf(file," ");
    }
  }
  fclose(file);
}

void iSaveBin(char* path, int size, int* data){
  int i;
  FILE* file;
  if((file = fopen(path,"w")) == NULL){
    puts("File open error");
    exit(0);
  }
  if(size != fwrite(data,sizeof(int),size,file)){
    fprintf(stderr,"Can't write all data\n");
  }
  fclose(file);
}

void fSaveBin(char* path, int size, FLOAT* data){
  int i;
  FILE* file;
  if((file = fopen(path,"w")) == NULL){
    puts("File open error");
    exit(0);
  }
  if(size != fwrite(data,sizeof(FLOAT),size,file)){
    fprintf(stderr,"Can't write all data\n");
  }
  fclose(file);
}
