/*********************************************************************
  ip_comm.cc
    user comm̿ѥдؿ
*********************************************************************/
#include "ip_table.h"
#include "ip.h"
#include "module.h"


/* I/Eѥåؿ -------------------------------------------------- */
#define _VS_COMM_CK(_VS_TYPE_VAL)					\
    vs_comm_q* q = &module_tab.comm_q[dist & COMM_KEY];			\
    while(q->next != NULL) {						\
	if((q->next->src == src) && (q->next->dist == dist)) break;	\
	q = q->next;							\
    }									\
    if(q->next != NULL) {						\
	*val = q->next->dt._VS_TYPE_VAL; /* åϾäʤ */	\
	return;								\
    } else {								\
	++module_tab.isWait;						\
    }


#define _VS_COMM_CK_1D(_VS_TYPE_VAL)					\
    int src  = s_x + d_x + module_tab.base[0]->div_info[0].index;	\
    int dist =       d_x + module_tab.base[0]->div_info[0].index;	\
    _VS_COMM_CK(_VS_TYPE_VAL)
void
Ip::comm_ck(int s_x, int*   val, int d_x)
{
    _VS_COMM_CK_1D(ival);
}
void
Ip::comm_ck(int s_x, FLOAT* val, int d_x)
{
    _VS_COMM_CK_1D(fval);
}
#undef _VS_COMM_CK_1D



#define _VS_COMM_CK_2D(_VS_TYPE_VAL)					     \
    int src  = ((s_y + d_y + module_tab.base[1]->div_info[1].index) << 16) | \
	        (s_x + d_x + module_tab.base[1]->div_info[0].index);	     \
    int dist = ((      d_y + module_tab.base[1]->div_info[1].index) << 16) | \
	        (      d_x + module_tab.base[1]->div_info[0].index);	     \
    _VS_COMM_CK(_VS_TYPE_VAL)
void
Ip::comm_ck(int s_x, int s_y, int*   val, int d_x, int d_y)
{
    _VS_COMM_CK_2D(ival);
}
void
Ip::comm_ck(int s_x, int s_y, FLOAT* val, int d_x, int d_y)
{
    _VS_COMM_CK_2D(fval);
}
#undef _VS_COMM_CK_2D



#define _VS_COMM_CK_3D(_VS_TYPE_VAL)						\
    int src	= ((s_z + d_z + module_tab.base[2]->div_info[2].index) << 20) |	\
	          ((s_y + d_y + module_tab.base[2]->div_info[1].index) << 10) |	\
		   (s_x + d_x + module_tab.base[2]->div_info[0].index);		\
    int dist	= ((    + d_z + module_tab.base[2]->div_info[2].index) << 20) |	\
	          ((    + d_y + module_tab.base[2]->div_info[1].index) << 10) |	\
		   (    + d_x + module_tab.base[2]->div_info[0].index);		\
    _VS_COMM_CK(_VS_TYPE_VAL)
void
Ip::comm_ck(int s_x, int s_y, int s_z, int*   val, int d_x, int d_y, int d_z)
{
    _VS_COMM_CK_3D(ival);
}
void
Ip::comm_ck(int s_x, int s_y, int s_z, FLOAT* val, int d_x, int d_y, int d_z)
{
    _VS_COMM_CK_3D(fval);
}
#undef _VS_COMM_CK_3D



/* user_comm ϴؿ ------------------------------------------------------ */
#define _VS_COMM_IN(_VS_TYPE_VAL)					\
									\
  RETRY:								\
    vs_comm_q* q = &module_tab.comm_q[dist & COMM_KEY];			\
    while(q->next != NULL) {						\
	if((q->next->src == src) && (q->next->dist == dist)) break;	\
	q = q->next;							\
    }									\
    if(q->next != NULL) {						\
	*val = q->next->dt._VS_TYPE_VAL;				\
	vs_comm_q* t = q->next->next;					\
	Pthread_mutex_lock(&exec_info.lock);				\
	delete q->next;							\
	q->next = t;							\
	Pthread_mutex_unlock(&exec_info.lock);				\
	return;								\
    } else {								\
	timeval tv;							\
	tv.tv_sec  =    0;						\
	tv.tv_usec = 1000;	/* polling Ԥ */			\
	Select(1, NULL, NULL, NULL, &tv);				\
	goto RETRY;							\
    }




#define _VS_COMM_IN_1D(_VS_TYPE_VAL)					\
    int src  = s_x + d_x + module_tab.base[0]->div_info[0].index;	\
    int dist =       d_x + module_tab.base[0]->div_info[0].index;	\
    _VS_COMM_IN(_VS_TYPE_VAL)
void
Ip::comm_in(int s_x, int*   val, int d_x)
{
    _VS_COMM_IN_1D(ival);
}
void
Ip::comm_in(int s_x, FLOAT* val, int d_x)
{
    _VS_COMM_IN_1D(fval);
}
#undef _VS_COMM_IN_1D



#define _VS_COMM_IN_2D(_VS_TYPE_VAL)					     \
    int src  = ((s_y + d_y + module_tab.base[1]->div_info[1].index) << 16) | \
	        (s_x + d_x + module_tab.base[1]->div_info[0].index);	     \
    int dist = ((      d_y + module_tab.base[1]->div_info[1].index) << 16) | \
	        (      d_x + module_tab.base[1]->div_info[0].index);	     \
    _VS_COMM_IN(_VS_TYPE_VAL)
void
Ip::comm_in(int s_x, int s_y, int*   val, int d_x, int d_y)
{
    _VS_COMM_IN_2D(ival);
}
void
Ip::comm_in(int s_x, int s_y, FLOAT* val, int d_x, int d_y)
{
    _VS_COMM_IN_2D(fval);
}

#undef _VS_COMM_IN_2D



#define _VS_COMM_IN_3D(_VS_TYPE_VAL)						\
    int src	= ((s_z + d_z + module_tab.base[2]->div_info[2].index) << 20) |	\
	          ((s_y + d_y + module_tab.base[2]->div_info[1].index) << 10) |	\
		   (s_x + d_x + module_tab.base[2]->div_info[0].index);		\
    int dist	= ((    + d_z + module_tab.base[2]->div_info[2].index) << 20) |	\
	          ((    + d_y + module_tab.base[2]->div_info[1].index) << 10) |	\
		   (    + d_x + module_tab.base[2]->div_info[0].index);		\
    _VS_COMM_IN(_VS_TYPE_VAL)
void
Ip::comm_in(int s_x, int s_y, int s_z, int*   val, int d_x, int d_y, int d_z)
{
    _VS_COMM_IN_3D(ival);
}
void
Ip::comm_in(int s_x, int s_y, int s_z, FLOAT* val, int d_x, int d_y, int d_z)
{
    _VS_COMM_IN_3D(fval);
}
#undef _VS_COMM_IN_3D




/* user_comm ϴؿ --------------------------------------------------------- */
#define _VS_COMM_OUT1(_VS_TYPE_VAL)				\
	/* ǤμϤ */				\
	vs_comm_q* q = &module_tab.comm_q[dist & COMM_KEY];	\
								\
	vs_comm_q* t 	     = new vs_comm_q;			\
	t->src       	     = src;				\
	t->dist      	     = dist;				\
	t->dt._VS_TYPE_VAL   = val;				\
	t->next	     	     = NULL;				\
								\
	Pthread_mutex_lock(&exec_info.lock);			\
	while(q->next != NULL) q = q->next;			\
	q->next	     = t;					\
	Pthread_mutex_unlock(&exec_info.lock);			\
								\
    } else {

#define _VS_COMM_OUT2(_VS_TYPE_VAL)				\
								\
	vs_comm_buf comm_buf;					\
	comm_buf.protocol	= pRetComm;			\
	comm_buf.src     	= src;				\
	comm_buf.dist    	= dist;				\
	comm_buf.dt._VS_TYPE_VAL= val;				\
								\
	Writen(wrtefd[host], &comm_buf, sizeof(vs_comm_buf));





#define _VS_COMM_OUT_1D(_VS_TYPE_VAL)						\
    int src  = s_x + module_tab.base[0]->div_info[0].index;			\
    int l_x  = d_x + s_x;							\
    int dist = l_x + module_tab.base[0]->div_info[0].index;			\
										\
    if((l_x >= 0) && (l_x < module_tab.base[0]->local->width)) { 		\
										\
        _VS_COMM_OUT1(_VS_TYPE_VAL);						\
										\
	/* ͥåȥؤ */						\
	int abs_x = l_x + module_tab.base[0]->div_info[0].index;		\
	int host  = abs_x / base1D;						\
										\
        _VS_COMM_OUT2(_VS_TYPE_VAL);						\
										\
    }
void
Ip::comm_out(int d_x, int   val, int s_x)
{
    _VS_COMM_OUT_1D(ival);
}
void
Ip::comm_out(int d_x, FLOAT val, int s_x)
{
    _VS_COMM_OUT_1D(fval);
}
#undef _VS_COMM_OUT_1D





#define _VS_COMM_OUT_2D(_VS_TYPE_VAL)						\
    int src  = ((s_y + module_tab.base[1]->div_info[1].index) << 16) |		\
	        (s_x + module_tab.base[1]->div_info[0].index);			\
    int l_x  = d_x + s_x;							\
    int l_y  = d_y + s_y;							\
    int dist = ((l_y + module_tab.base[1]->div_info[1].index) << 16) |		\
	        (l_x + module_tab.base[1]->div_info[0].index);			\
										\
    if((l_x >= 0) && (l_x < module_tab.base[1]->local->width)			\
    && (l_y >= 0) && (l_y < module_tab.base[1]->local->heigh)){			\
										\
        _VS_COMM_OUT1(_VS_TYPE_VAL);						\
										\
	/* ͥåȥؤ */						\
	int abs_x = l_x + module_tab.base[1]->div_info[0].index;		\
	int abs_y = l_y + module_tab.base[1]->div_info[1].index;		\
	int host  = module_tab.base[1]->div_hint.x_divide			\
	                            * (abs_y / base2D[1]) + abs_x / base2D[0];	\
										\
        _VS_COMM_OUT2(_VS_TYPE_VAL);						\
										\
    }
void
Ip::comm_out(int d_x, int d_y, int   val, int s_x, int s_y)
{
    _VS_COMM_OUT_2D(ival);
}
void
Ip::comm_out(int d_x, int d_y, FLOAT val, int s_x, int s_y)
{
    _VS_COMM_OUT_2D(fval);
}
#undef _VS_COMM_OUT_2D




#define _VS_COMM_OUT_3D(_VS_TYPE_VAL)						\
    int src  = ((s_z + module_tab.base[2]->div_info[2].index) << 20) |		\
	       ((s_y + module_tab.base[2]->div_info[1].index) << 10) |		\
	        (s_x + module_tab.base[2]->div_info[0].index);			\
    int l_x  = d_x + s_x;							\
    int l_y  = d_y + s_y;							\
    int l_z  = d_z + s_z;							\
    int dist = ((l_z + module_tab.base[2]->div_info[2].index) << 20) |		\
	       ((l_y + module_tab.base[2]->div_info[1].index) << 10) |		\
	        (l_x + module_tab.base[2]->div_info[0].index);			\
										\
    if((l_x >= 0) && (l_x < module_tab.base[2]->local->width)			\
    && (l_y >= 0) && (l_y < module_tab.base[2]->local->heigh)			\
    && (l_z >= 0) && (l_z < module_tab.base[2]->local->depth)){			\
										\
        _VS_COMM_OUT1(_VS_TYPE_VAL);						\
										\
	/* ͥåȥؤ */						\
	int abs_x = l_x + module_tab.base[2]->div_info[0].index;		\
	int abs_y = l_y + module_tab.base[2]->div_info[1].index;		\
	int abs_z = l_z + module_tab.base[2]->div_info[2].index;		\
	int host = ((abs_z / base3D[2])  * module_tab.base[2]->div_hint.y_divide\
	          + (abs_y / base3D[1])) * module_tab.base[2]->div_hint.x_divide\
		  +  abs_x / base3D[0];						\
										\
        _VS_COMM_OUT2(_VS_TYPE_VAL);						\
										\
    }
void
Ip::comm_out(int d_x, int d_y, int d_z, int   val, int s_x, int s_y, int s_z)
{
    _VS_COMM_OUT_3D(ival);
}
void
Ip::comm_out(int d_x, int d_y, int d_z, FLOAT val, int s_x, int s_y, int s_z)
{
    _VS_COMM_OUT_3D(fval);
}
#undef _VS_COMM_OUT_3D




// comm̿  ------------------------------------------------
void
Ip::RetComm(int host)
{
    // Ʊ¤ʤΤǲǽ
    vs_comm_q* ret = new vs_comm_q;
    Readn(readfd[host], ret, sizeof(vs_comm_buf) - sizeof(int));

    ret->next = NULL;

    vs_comm_q* q = &module_tab.comm_q[ret->dist & COMM_KEY];
    Pthread_mutex_lock(&exec_info.lock);
    while(q->next != NULL)
	q = q->next;
    q->next = ret;
    Pthread_mutex_unlock(&exec_info.lock);
}

