/*********************************************************************
  ip_send.cc
    ̿ ̴ؿƤӽФ륳(IP)
*********************************************************************/
#include "ip_table.h"
#include "ip.h"
#include "module.h"


// ⥸塼νλϢ  -------------------------------------
void
Ip::SendDone(){    Protocol(pDone);    }


// ƱʤȤꤢΥƥȡѹ---------------------
void
Ip::SendSync()
{
    Pthread_mutex_lock(&slock);

    Protocol(pSync);

    Pthread_cond_wait(&scond, &slock);
    Pthread_mutex_unlock(&slock);
}


// I/Eѥǡꥯȴؿٱݡ ----------------------
void
Ip::GetReq()
{
    int protocol = pReqCell_nw;

    for(int i=0; i<exec_info.host_num; i++) {
	if(module_tab.host_cnt[i]) {
	    Writen(wrtefd[i], &protocol, sizeof(int));
	    Writen(wrtefd[i], &module_tab.host_cnt[i], sizeof(int));
	    Writen(wrtefd[i], module_tab.send_buf + i * MAX_IO, \
		                  sizeof(vs_reqgrp)*module_tab.host_cnt[i]);
	    module_tab.host_cnt[i] = 0;
	}
    }
}

// ̾parallelʸǤγɤ߹ߡʤξɤߡ ------------------
int
Ip::iGetNow(int host, vs_request* req)
{
    Pthread_mutex_lock(&exec_info.lock);

    Writen(wrtefd[host], req, sizeof(vs_request));

    Pthread_cond_wait(&exec_info.cond, &exec_info.lock);
    Pthread_mutex_unlock(&exec_info.lock);

    return cell.ival;
}
FLOAT
Ip::fGetNow(int host, vs_request* req)
{
    Pthread_mutex_lock(&exec_info.lock);

    Writen(wrtefd[host], req, sizeof(vs_request));

    Pthread_cond_wait(&exec_info.cond, &exec_info.lock);
    Pthread_mutex_unlock(&exec_info.lock);

    return cell.fval;
}





// ͤν񤭽Фؿ ---------------------------------------------
void
Ip::SetReq(int host, vs_write* req)
{  Writen(wrtefd[host], req, sizeof(vs_write));  }



//   ---------------------------------------------
void
Ip::SendUnion(vs_data* ptr, int vid, int type)
{
  UnionInfo uni;
  uni.protocol = pUnion;
  uni.id       = vid;
  uni.type     = type;
  data	       = ptr;
  extern int thread_count;
  Pthread_mutex_lock(&exec_info.lock);
  if(++thread_count == exec_info.div_num){
    thread_count = 0;
    //fprintf(stderr,"done Union\n");
    Writen(om_fd, &uni,   sizeof(UnionInfo));
    
    if(ptr->type != vsAGGRIGATE) {
      if(ptr->type & INT) {
	Writen(om_fd, ptr->val, ptr->size * sizeof(int));
      } else {
	Writen(om_fd, ptr->val, ptr->size * sizeof(FLOAT));
      }
    }
    // ˤʤȤ
    Pthread_cond_wait(&exec_info.cond, &exec_info.lock);
    Pthread_mutex_unlock(&exec_info.lock);
  } else {
    //fprintf(stderr,"count = %d\n",thread_count);
    Pthread_cond_wait(&exec_info.cond, &exec_info.lock);
    Pthread_mutex_unlock(&exec_info.lock);
  }
}

// ɼ  ----------------------------------------------------
void
Ip::SendVote(vs_data* ptr, int vid, int pos, int val)
{
    UnionInfo vote;	// ȤꤢҼ
    vote.protocol = pVote;
    vote.id 	  = vid;
    vote.type	  = pos;

    Writen(om_fd, &vote, sizeof(UnionInfo));
    Writen(om_fd,  &val, sizeof(int));
}

void
Ip::SendVote(vs_data* ptr, int vid, int pos, FLOAT val)
{
    UnionInfo vote;	// ȤꤢҼ
    vote.protocol = pVote;
    vote.id 	  = vid;
    vote.type	  = pos;

    Writen(om_fd, &vote, sizeof(UnionInfo));
    Writen(om_fd,  &val, sizeof(FLOAT));
}

