/*********************************************************************
  ip_struct.h
    IP ǻѤƼﹽ¤Τʤɤ
*********************************************************************/
#include "vios_struct.h"

#ifndef __IP_STRUCT_H
#define __IP_STRUCT_H


union vs_dtype {
    int		ival;
    FLOAT	fval;
};

/* ---------  ⥸塼֥ǡ̿ѥХåե --------*/

struct vs_request {		// GetNowΤStructure
    int	protocol;
    int id;
    int index;
};

struct vs_return {		// RetCellΤStructure
    int 	protocol;
    vs_dtype	dt;
};

struct vs_reqgrp {		// GetReqΤStructure
    int id;
    int	index;
};

struct vs_reqcache {		// SyncCacheΤStructure
    int	protocol;
    int tgt_id;
    int cache_id;
};

struct vs_retgrp {		// RetCell_nwΤStructure
    int 	id;
    int 	index;
    vs_dtype 	dt;
};

struct vs_write {
    int		protocol;
    int		id;
    int		index;
    vs_dtype	dt;
};

// I/Eˤ̿
struct vs_io_buf {
    int			id;	// ѿid
    int			index;
    int			flag;
    vs_dtype		dt;

    vs_io_buf*		next;
};

// comm̿Τ
struct vs_comm_buf {
    int			protocol;
    int			src;	// 
    int			dist;	// 
    vs_dtype		dt;
};

struct vs_comm_q {
    int			src;	// 
    int			dist;	// 
    vs_dtype		dt;

    vs_comm_q*		next;
};

/* -----------  ipǤΥǡ ¤  ------------*/

struct vs_data {
  int	   		id;
  int			type;
  int			dtype;
  size_t 		size;
  DivHint		div_hint;	// ʬˡλؼ
//  -------------------------		// ޤǤOMƱ
  
  DimInfo*		orig;		// ΤǤξ
  DimInfo*		local;		// ȤͭʬΥǡ
  DimInfo*		work;		// ȤʬΥǡ
  
  DivInfo*		div_info;       // ȤʬΥǡ
  size_t		dsize;		// ȤʬΥ
  int			cache[6];	// 岼Υå
  
  struct vs_data*  	next;
  void*  		val;
  int                   IS;             // åѡ
  int                   c;              // åΥå
  int *                 index;
  int *                 gxtable;
  //int*                  IE;             // ϰ֤Ƚλ
};

#define VS_DATA_SIZE	(sizeof(int) * 3 + sizeof(size_t) + sizeof(DivHint))


extern ExecInfo	exec_info;

// parallelʸǺ륹åɤǻ
typedef struct{
  int sx; // xγϰ
  int ex; // xνλ
  int sy; // yγϰ
  int ey; // yνλ
  int sz; // zγϰ
  int ez; // zνλ
} vs_StartEnd;

#endif
