/********************************************************************
  Copyright (c) 1992-2000 Iwata Lab. All Rights Reserved.

  queue.h
  I/E Ѥ ¸ queue ؿʤΥեǴ
*********************************************************************/
#ifndef __QUEUE_H
#define __QUEUE_H

class vs_queue
{
    struct cell {
	int x;
	int y;
	int z;
	cell* next;
    };
    cell	top;
    cell*	tail;
  public:
    int		count;
    vs_queue()
    {	tail = &top; count = 0;    };
   ~vs_queue()
    {
	cell* now;
	while(count-- > 0) {
	    now = top.next; top.next = now->next;
	    delete now;
	}
    };
    void	push(int x);
    void	 pop(int* x);
    void	push(int x, int y);
    void	 pop(int* x, int* y);
};

inline void
vs_queue::push(int x, int y)
{
    cell* now = new cell;
    now->x = x; now->y = y;
    count++;
    now->next = NULL;

    tail->next = now; tail = now;
};

// if(count > 0)ϳƼȽ(Τǳǧ뤫ɤ)
inline void
vs_queue::pop(int* x)
{
    cell* now = top.next;

    *x = now->x;

    top.next = now->next;
    delete now;

    if(count-- == 1) tail = &top;
};

inline void
vs_queue::push(int x)
{
    cell* now = new cell;
    now->x = x;
    count++;
    now->next = NULL;

    tail->next = now; tail = now;
};

// if(count > 0)ϳƼȽ(Τǳǧ뤫ɤ)
inline void
vs_queue::pop(int* x, int* y)
{
    cell* now = top.next;

    *x = now->x; *y = now->y;

    top.next = now->next;
    delete now;

    if(count-- == 1) tail = &top;
};

#endif
